program Measure;

{$R 'uac.res' 'uac.rc'}

uses
  ShareMem,
  Forms,
  Controls,
  MainFrm in '..\Forms\MainFrm.pas' {MainForm},
  ProjectManagerFme in '..\Frames\ProjectManagerFme.pas' {ProjectManagerFrame: TFrame},
  UtilMethods in '..\Units\UtilMethods.pas',
  ProjectManagerDm in '..\DataModules\ProjectManagerDm.pas' {ProjectManagerData: TDataModule},
  Connections in '..\Units\Connections.pas',
  TransFile in '..\Units\TransFile.pas',
  ZhAPI in '..\Units\ZhAPI.pas',
  CompactDB in '..\Units\CompactDB.pas',
  OpenProjectManager in '..\Units\OpenProjectManager.pas',
  ProjectData in '..\Units\ProjectData.pas',
  UpdateDataBase in '..\Units\UpdateDataBase.pas',
  DataBaseTables in '..\Units\DataBaseTables.pas',
  ConfigDoc in '..\Units\ConfigDoc.pas',
  SupportUnit in '..\Units\SupportUnit.pas',
  StandardLibs in '..\Units\StandardLibs.pas',
  StandardLib in '..\Units\StandardLib.pas',
  NewProjectFrm in '..\Forms\NewProjectFrm.pas' {NewProjectForm},
  ProjectFme in '..\Frames\ProjectFme.pas' {ProjectFrame: TFrame},
  StandardBillsDm in '..\DataModules\StandardBillsDm.pas' {StandardBillsData: TDataModule},
  StandardBillsFme in '..\Frames\StandardBillsFme.pas' {StandardBillsFrame: TFrame},
  StandardLibsFme in '..\Frames\StandardLibsFme.pas' {StandardLibsFrame: TFrame},
  BillsDm in '..\DataModules\BillsDm.pas' {BillsData: TDataModule},
  BillsMeasureFme in '..\Frames\BillsMeasureFme.pas' {BillsMeasureFrame: TFrame},
  Globals in '..\Units\Globals.pas',
  StageDm in '..\DataModules\StageDm.pas' {StageData: TDataModule},
  ExcelImport in '..\Units\ExcelImport.pas',
  CacheTree in '..\Units\CacheTree.pas',
  MCacheTree in '..\Units\MCacheTree.pas',
  ProjectPropertiesFrm in '..\Forms\ProjectPropertiesFrm.pas' {ProjectPropertiesForm},
  ProjectProperty in '..\Units\ProjectProperty.pas',
  FormulaCalc in '..\Units\FormulaCalc.pas',
  BillsCommand in '..\Units\BillsCommand.pas',
  PhaseData in '..\Units\PhaseData.pas',
  PhaseProperty in '..\Units\PhaseProperty.pas',
  BillsClipboard in '..\Units\BillsClipboard.pas',
  BillsTree in '..\Units\BillsTree.pas',
  ProjectCommands in '..\Units\ProjectCommands.pas',
  PhaseCompareDm in '..\DataModules\PhaseCompareDm.pas' {PhaseCompareData: TDataModule},
  PhaseCompareFme in '..\Frames\PhaseCompareFme.pas' {PhaseCompareFrame: TFrame},
  OptionFrm in '..\Forms\OptionFrm.pas' {OptionForm},
  DealPaymentDm in '..\DataModules\DealPaymentDm.pas' {DealPaymentData: TDataModule},
  DealPaymentFme in '..\Frames\DealPaymentFme.pas' {DealPaymentFrame: TFrame},
  PhasePayDm in '..\DataModules\PhasePayDm.pas' {PhasePayData: TDataModule},
  BillsGatherFme in '..\Frames\BillsGatherFme.pas' {BillsGatherFrame: TFrame},
  BillsGatherDm in '..\DataModules\BillsGatherDm.pas' {BillsGatherData: TDataModule},
  ZJJLFme in '..\Frames\ZJJLFme.pas' {ZJJLFrame: TFrame},
  ZJJLDm in '..\DataModules\ZJJLDm.pas' {ZJJLData: TDataModule},
  BGLFme in '..\Frames\BGLFme.pas' {BGLFrame: TFrame},
  BGLDm in '..\DataModules\BGLDm.pas' {BGLData: TDataModule},
  StaffDm in '..\DataModules\StaffDm.pas' {StaffData: TDataModule},
  ConstUnit in '..\Units\ConstUnit.pas',
  PHPWebDm in '..\DataModules\PHPWebDm.pas' {PHPWeb: TDataModule},
  MergeTextFrm in '..\Forms\MergeTextFrm.pas' {MergeTextForm},
  BGLSelectFrm in '..\Forms\BGLSelectFrm.pas' {BGLSelectForm},
  WebNewTenderFrm in '..\Forms\WebNewTenderFrm.pas' {WebNewTenderForm},
  ExportExcel in '..\Units\ExportExcel.pas',
  ReportsFrm in '..\Forms\ReportsFrm.pas' {ReportsForm},
  ReportManager in '..\Units\ReportManager.pas',
  BillsCompileDm in '..\DataModules\BillsCompileDm.pas' {BillsCompileData: TDataModule},
  BillsCompileFme in '..\Frames\BillsCompileFme.pas' {BillsCompileFrame: TFrame},
  BillsMeasureDm in '..\DataModules\BillsMeasureDm.pas' {BillsMeasureData: TDataModule},
  PasswordInputFrm in '..\Forms\PasswordInputFrm.pas' {PasswordInputForm},
  AboutFrm in '..\Forms\AboutFrm.pas' {AboutForm},
  AuthFrm in '..\Forms\AuthFrm.pas' {AuthorizeForm},
  mEncryptUnit in '..\Encrypt\mEncryptUnit.pas',
  mEncryptPWD in '..\Encrypt\mEncryptPWD.pas',
  mSNSEncrypt in '..\Encrypt\mSNSEncrypt.pas',
  mR1Encrypt in '..\Encrypt\mR1Encrypt.pas',
  mEncryptEditions in '..\Encrypt\mEncryptEditions.pas',
  mEncryptTypes in '..\Encrypt\mEncryptTypes.pas',
  mConnectEncrypt in '..\Encrypt\NetClient\mConnectEncrypt.pas',
  CryptUtils in '..\Encrypt\CryptUtils.pas',
  EncryptDog in '..\Encrypt\EncryptDog.pas',
  ScFileArchiver in '..\Encrypt\ScFileArchiver.pas',
  SearchFme in '..\Frames\SearchFme.pas' {SearchFrame: TFrame},
  BatchInsertBillsFrm in '..\Forms\BatchInsertBillsFrm.pas' {BatchInsertBillsForm},
  SearchDm in '..\DataModules\SearchDm.pas' {SearchData: TDataModule},
  CslJson in '..\Units\CslJson.pas',
  FindUserFrm in '..\Forms\FindUserFrm.pas' {FindUserForm},
  ImportExcelHintFrm in '..\Forms\ImportExcelHintFrm.pas' {ImportExcelHintForm},
  CheckerFme in '..\Frames\CheckerFme.pas' {CheckerFrame: TFrame},
  OrderCheckerFme in '..\Frames\OrderCheckerFme.pas' {OrderCheckerFrame: TFrame},
  ReportAdjustFrm in '..\Forms\ReportAdjustFrm.pas' {ReportAdjustForm},
  DealBillsDm in '..\DataModules\DealBillsDm.pas' {DealBillsData: TDataModule},
  BatchReplaceBillsFrm in '..\Forms\BatchReplaceBillsFrm.pas' {BatchReplaceBillsForm},
  MD5Unit in '..\Units\MD5Unit.pas',
  MainDataListDm in '..\DataModules\MainDataListDm.pas' {MainListData: TDataModule},
  mProgressFrm in '..\Forms\mProgressFrm.pas',
  rmGclBillsBGDm in '..\DataModules\ReportMemoryDm\rmGclBillsBGDm.pas' {rmGclBillsBGData: TDataModule},
  rmGclBillsCompareDm in '..\DataModules\ReportMemoryDm\rmGclBillsCompareDm.pas' {rmGclBillsCompareData: TDataModule},
  rmCacheData in '..\DataModules\ReportMemoryDm\rmCacheData.pas',
  rmSelectProjectFrm in '..\Forms\rmSelectProjectFrm.pas' {ProjectSelectForm},
  rmGridHeaderDm in '..\DataModules\ReportMemoryDm\rmGridHeaderDm.pas' {rmGridHeaderData: TDataModule},
  rmFxBillsCompareDm in '..\DataModules\ReportMemoryDm\rmFxBillsCompareDm.pas' {rmFxBillsCompareData: TDataModule},
  rmBGLExecutionDm in '..\DataModules\ReportMemoryDm\rmBGLExecutionDm.pas' {rmBGLExecutionData: TDataModule},
  rmGclBillsAddDm in '..\DataModules\ReportMemoryDm\rmGclBillsAddDm.pas' {rmGclBillsAddData: TDataModule},
  rmFxBillsAddDm in '..\DataModules\ReportMemoryDm\rmFxBillsAddDm.pas' {rmFxBillsAddData: TDataModule},
  rmBillsGatherDm in '..\DataModules\ReportMemoryDm\rmBillsGatherDm.pas' {rmBillsGatherData: TDataModule},
  ConditionalDefines in '..\Units\ConditionalDefines.pas',
  ProgressHintFrm in '..\Forms\ProgressHintFrm.pas' {ProgressHintForm},
  rmTestFrm in '..\DataModules\ReportMemoryDm\rmTestFrm.pas' {rmTestForm},
  rmGclBillsAuditCompareDm in '..\DataModules\ReportMemoryDm\rmGclBillsAuditCompareDm.pas' {rmGclBillsAuditCompareData: TDataModule},
  CheckAndClearFrm in '..\Forms\CheckAndClearFrm.pas' {CheckAndClearForm},
  DealBillsFrm in '..\Forms\DealBillsFrm.pas' {DealBillsForm},
  BillsBookmarkDm in '..\DataModules\BillsBookmarkDm.pas' {BillsBookmarkData: TDataModule},
  BookmarkFme in '..\Frames\BookmarkFme.pas' {BookmarkFrame: TFrame},
  rmDealInfosDm in '..\DataModules\ReportMemoryDm\rmDealInfosDm.pas' {rmDealInfosData: TDataModule},
  rmXmjBGLDetailDm in '..\DataModules\ReportMemoryDm\rmXmjBGLDetailDm.pas' {rmXmjBGLDetailData: TDataModule},
  WelcomeFrm in '..\Forms\WelcomeFrm.pas' {WelcomeForm},
  rmOtherReport1Dm in '..\DataModules\ReportMemoryDm\rmOtherReport1Dm.pas' {rmOtherReport1Data: TDataModule},
  rmGcl_XmjBillsDm in '..\DataModules\ReportMemoryDm\rmGcl_XmjBillsDm.pas' {rmGcl_XmjBillsData: TDataModule},
  CheckerMemoFrm in '..\Forms\CheckerMemoFrm.pas' {CheckerMemoForm},
  TenderBackupManager in '..\Units\TenderBackupManager.pas',
  UpFileManageUnit in '..\Units\UpFileManageUnit.pas',
  UpFileManageFrame in '..\Forms\UpFileManageFrame.pas',
  UpFileFrame in '..\Forms\UpFileFrame.pas',
  SheetSelectFrm in '..\Forms\SheetSelectFrm.pas' {SheetSelectForm},
  DealBillsFme in '..\Frames\DealBillsFme.pas' {DealBillsFrame: TFrame},
  Checker in '..\Units\Checker.pas',
  AuditSelectFrm in '..\Forms\ReportInteractFrms\AuditSelectFrm.pas' {AuditSelctForm},
  ReportInteractInfo in '..\Units\ReportInteractInfo.pas',
  IPFrm in '..\Forms\IPFrm.pas' {IPForm},
  LoginFrm in '..\Forms\LoginFrm.pas' {LoginForm},
  rmGclBillsPlaneDm in '..\DataModules\ReportMemoryDm\rmGclBillsPlaneDm.pas' {rmGclBillsPlaneData: TDataModule},
  StageCompareDm in '..\DataModules\StageCompareDm.pas' {StageCompareData: TDataModule},
  mDataRecord in '..\Units\mDataRecord.pas',
  BGLClipboard in '..\Units\BGLClipboard.pas',
  rmMentalCustomized1Dm in '..\DataModules\ReportMemoryDm\rmMentalCustomized1Dm.pas' {rmMentalCustomized1Data: TDataModule},
  rmCustomized2Dm in '..\DataModules\ReportMemoryDm\rmCustomized2Dm.pas' {rmCustomized2Data: TDataModule},
  CalcDecimal in '..\Units\CalcDecimal.pas',
  BillsPasteSelectFrm in '..\Forms\BillsPasteSelectFrm.pas' {BillsPasteSelectForm},
  mProgressProFrm in '..\Forms\mProgressProFrm.pas' {ProgressProForm},
  DetailExcelImport in '..\Units\DetailExcelImport.pas',
  tpSelectTendersFrm in '..\TenderPartition\tpSelectTendersFrm.pas' {SelectTendersForm},
  tpGatherTree in '..\TenderPartition\tpGatherTree.pas',
  tpPeg in '..\TenderPartition\tpPeg.pas',
  mPegFilter in '..\Units\mPegFilter.pas',
  tpMainFrm in '..\TenderPartition\tpMainFrm.pas' {tpMainForm},
  tpMainData in '..\TenderPartition\tpMainData.pas',
  tpSelectTenderDm in '..\TenderPartition\tpSelectTenderDm.pas' {tpSelectTenderData: TDataModule},
  tpSelectTenderNode in '..\TenderPartition\tpSelectTenderNode.pas',
  tpPegBlock in '..\TenderPartition\tpPegBlock.pas',
  tpPartTender in '..\TenderPartition\tpPartTender.pas',
  tpTrialPegInputFrm in '..\TenderPartition\tpTrialPegInputFrm.pas' {TrialPegInputForm},
  tpPeg_GclDm in '..\TenderPartition\tpPeg_GclDm.pas' {tpPeg_GclData: TDataModule},
  tpBaseGatherData in '..\TenderPartition\tpBaseGatherData.pas',
  tpPartTenderFme in '..\TenderPartition\tpPartTenderFme.pas' {tpPartTenderFrame: TFrame},
  tpPeg_GclFme in '..\TenderPartition\tpPeg_GclFme.pas' {tpPeg_GclFrame: TFrame},
  tpGatherGcl in '..\TenderPartition\tpGatherGcl.pas',
  tpPegGclGatherDm in '..\TenderPartition\tpPegGclGatherDm.pas' {tpPegGclGatherData: TDataModule},
  tpPegGclGatherFme in '..\TenderPartition\tpPegGclGatherFme.pas' {tpPegGclGatherFrame: TFrame},
  tpNoPegDm in '..\TenderPartition\tpNoPegDm.pas' {tpNoPegData: TDataModule},
  tpPricePartSettingFrm in '..\TenderPartition\tpPricePartSettingFrm.pas' {tpPricePartSettingForm},
  tpPartTenderSet in '..\TenderPartition\tpPartTenderSet.pas',
  tpPartTenderSetFme in '..\TenderPartition\tpPartTenderSetFme.pas' {tpPartTenderSetFrame: TFrame},
  tpPegPartSettingFrm in '..\TenderPartition\tpPegPartSettingFrm.pas' {tpPegPartSettingForm},
  PriceMarginFme in '..\Frames\PriceMarginFme.pas' {PriceMarginFrame: TFrame},
  ProjectGLDm in '..\DataModules\ProjectGLDm.pas' {ProjectGLData: TDataModule},
  ProjectGLFme in '..\Frames\ProjectGLFme.pas' {ProjectGLFrame: TFrame},
  PriceMarginBillsDm in '..\DataModules\PriceMarginBillsDm.pas' {PriceMarginBillsData: TDataModule},
  PriceMarginBillsFme in '..\Frames\PriceMarginBillsFme.pas' {PriceMarginBillsFrame: TFrame},
  GclBillsGatherModel in '..\Units\GclBillsGatherModel.pas',
  DetailGLDm in '..\DataModules\DetailGLDm.pas' {DetailGLData: TDataModule},
  SelectDetailGLsFrm in '..\Forms\SelectDetailGLsFrm.pas' {SelectDetailGLsForm},
  PriceMarginClipboard in '..\Units\PriceMarginClipboard.pas',
  BaseClipboard in '..\Units\BaseClipboard.pas',
  rmHaBaiCustomizedDm in '..\DataModules\ReportMemoryDm\rmHaBaiCustomizedDm.pas' {rmHaBaiCustomizedData: TDataModule},
  DealPayPlanFrm in '..\Forms\DealPayPlanFrm.pas' {DealPayPlanForm},
  ColVisibleManager in '..\Units\ColVisibleManager.pas',
  ReportPrepare in '..\Report\ReportPrepare.pas',
  rdpBillsGatherDm in '..\Report\DataPrepare\rdpBillsGatherDm.pas' {rdpBillsGatherData: TDataModule},
  rdpTables in '..\Report\DataPrepare\rdpTables.pas',
  ReportConnection in '..\Report\ReportConnection.pas',
  rgpGatherControl in '..\Report\ProjGather\rgpGatherControl.pas',
  rpgBillsCalcDm in '..\Report\ProjGather\rpgBillsCalcDm.pas' {rpgBillsCalcData: TDataModule},
  rpgBillsDm in '..\Report\ProjGather\rpgBillsDm.pas' {rpgBillsData: TDataModule},
  rpgGatherControl in '..\Report\ProjGather\rpgGatherControl.pas',
  rpgGatherData in '..\Report\ProjGather\rpgGatherData.pas',
  rpgGatherProjDm in '..\Report\ProjGather\rpgGatherProjDm.pas' {rpgGatherProjData: TDataModule},
  rProjGatherTables in '..\Report\ProjGather\rProjGatherTables.pas',
  GatherProjInfo in '..\ProjGather\GatherProjInfo.pas',
  ProjGather in '..\ProjGather\ProjGather.pas',
  ProjGatherCalcData in '..\ProjGather\ProjGatherCalcData.pas',
  ProjGatherSelectFrm in '..\ProjGather\ProjGatherSelectFrm.pas' {ProjGatherSelectForm},
  ProjGatherTree in '..\ProjGather\ProjGatherTree.pas',
  CalcData in '..\Units\CalcData.pas',
  DealBillsExcelImport in '..\Units\DealBillsExcelImport.pas',
  ExcelImport_GclBills in '..\Units\ExcelImport_GclBills.pas',
  ExcelImport_Bills in '..\Units\ExcelImport_Bills.pas',
  MeasureGatherZJJL in '..\Units\MeasureGatherZJJL.pas',
  superobject in '..\Units\superobject\superobject.pas',
  OtherMeasureOnceDm in '..\DataModules\OtherMeasureOnceDm.pas' {OtherMeasureOnceData: TDataModule},
  OtherMeasurePhaseDm in '..\DataModules\OtherMeasurePhaseDm.pas' {OtherMeasurePhaseData: TDataModule},
  OMPhaseRecord in '..\Units\DataRecord\OMPhaseRecord.pas',
  rmWeiWuZjjlGatherDm in '..\DataModules\ReportMemoryDm\rmWeiWuZjjlGatherDm.pas' {rmWeiWuZjjlGatherData: TDataModule},
  LogUtils in '..\Units\LogUtils.pas',
  ProjGatherDealPay in '..\ProjGather\ProjGatherDealPay.pas',
  ProjGatherProperties in '..\ProjGather\ProjGatherProperties.pas',
  ProjGatherSelectFme in '..\ProjGather\ProjGatherSelectFme.pas' {ProjGatherSelectFrame: TFrame},
  rpgZoneGatherControl in '..\Report\ProjGather\Zone\rpgZoneGatherControl.pas',
  rpgZoneProjGatherSelectFrm in '..\Report\ProjGather\Zone\rpgZoneProjGatherSelectFrm.pas' {rpgZoneProjGatherSelectForm},
  rpgDealPayDm in '..\Report\ProjGather\rpgDealPayDm.pas' {rgpDealPayData: TDataModule},
  OtherMeasureFme in '..\Frames\OtherMeasureFme.pas' {OtherMeasureFrame: TFrame},
  stgExcelExport in '..\SubTenderGather\stgExcelExport.pas',
  stgGather in '..\SubTenderGather\stgGather.pas',
  stgGatherCacheData in '..\SubTenderGather\stgGatherCacheData.pas',
  stgGatherControl in '..\SubTenderGather\stgGatherControl.pas',
  stgGatherDm in '..\SubTenderGather\stgGatherDm.pas' {stgGatherData: TDataModule},
  stgGatherUtils in '..\SubTenderGather\stgGatherUtils.pas',
  stgResultFrm in '..\SubTenderGather\stgResultFrm.pas' {stgResultForm},
  stgSelectFileFrm in '..\SubTenderGather\stgSelectFileFrm.pas' {stgGclSelectFileForm},
  stgSubGatherFile in '..\SubTenderGather\stgSubGatherFile.pas',
  stgSubGatherFileDm in '..\SubTenderGather\stgSubGatherFileDm.pas' {stgSubGatherData: TDataModule},
  stgTables in '..\SubTenderGather\stgTables.pas',
  ReportManagerFrm in '..\Forms\ReportManagerFrm.pas' {ReportManagerForm},
  ReportHistoryFrm in '..\Forms\ReportHistoryFrm.pas' {ReportHistoryForm},
  ReportManagerDM in '..\DataModules\ReportManagerDM.pas' {Reports: TDataModule},
  UpFileSelectOnLineFrm in '..\Forms\UpFileSelectOnLineFrm.pas' {UpFileSelectOnLineForm},
  SelectOnlineSignPhaseFrm in '..\Forms\SelectOnlineSignPhaseFrm.pas' {SelectOnlineSignPhaseForm},
  SetGuestFrm in '..\Forms\SetGuestFrm.pas' {SetGuestForm},
  SignOnlineReportsFrm in '..\Forms\SignOnlineReportsFrm.pas' {SignOnlineReportsForm},
  SignReports in '..\Units\SignReports.pas',
  TemplateManagerHelper in '..\Units\TemplateManagerHelper.pas',
  RenameSignReportFrm in '..\Forms\RenameSignReportFrm.pas' {RenameSignReportForm},
  DbTreeImport in '..\Units\DbTreeImport.pas',
  DbTreeDm in '..\DataModules\DbTreeDm.pas' {DbTreeData: TDataModule},
  DebugUsers in '..\Units\DebugUsers.pas',
  FileDownLoadFrm in '..\Forms\FileDownLoadFrm.pas' {FileDownLoadForm},
  rmZhongKaiDm in '..\DataModules\ReportMemoryDm\rmZhongKaiDm.pas' {rmZhongKaiData: TDataModule},
  BillsPosTree in '..\Units\BillsPosTree.pas',
  rmWuJiuZqzfGatherDm in '..\DataModules\ReportMemoryDm\rmWuJiuZqzfGatherDm.pas' {rmWuJiuZqzfGatherData: TDataModule},
  DealPayFinalDm in '..\DataModules\DealPayFinalDm.pas' {DealPayFinalData: TDataModule},
  AttachmentInfoDm in '..\DataModules\AttachmentInfoDm.pas' {AttachmentInfoData: TDataModule},
  uGetMacAddr in '..\Units\uGetMacAddr.pas',
  stgGclGatherControl in '..\SubTenderGatherGcl\stgGclGatherControl.pas',
  stgGclSelectFileFrm in '..\SubTenderGatherGcl\stgGclSelectFileFrm.pas' {stgSelectFileForm},
  stgGatherGclCacheData in '..\SubTenderGatherGcl\stgGatherGclCacheData.pas',
  stgGclGatherDm in '..\SubTenderGatherGcl\stgGclGatherDm.pas' {stgGatherGclData: TDataModule},
  stgGclResultFrm in '..\SubTenderGatherGcl\stgGclResultFrm.pas' {stgGclResultForm},
  stgGclTables in '..\SubTenderGatherGcl\stgGclTables.pas',
  stgGclSubGatherFile in '..\SubTenderGatherGcl\stgGclSubGatherFile.pas',
  stgGclSubGatherFileDm in '..\SubTenderGatherGcl\stgGclSubGatherFileDm.pas' {stgGclSubGatherData: TDataModule},
  stgGclGather in '..\SubTenderGatherGcl\stgGclGather.pas',
  stgGclImportHint in '..\SubTenderGatherGcl\stgGclImportHint.pas',
  stgGclImportHintFrm in '..\SubTenderGatherGcl\stgGclImportHintFrm.pas' {stgGclImportHintForm},
  rmBGBillsGatherDm in '..\DataModules\ReportMemoryDm\rmBGBillsGatherDm.pas' {rmBGBillsGatherData: TDataModule},
  rmBillsPhaseGatherDm in '..\DataModules\ReportMemoryDm\rmBillsPhaseGatherDm.pas' {rmBillsPhaseGatherData: TDataModule},
  rmfImportFrm in '..\Forms\rmfImportFrm.pas' {rmfImportForm};

//UpFileSelectOnLineFrm in '..\Forms\UpFileSelectOnLineFrm.pas' {UpFileSelectOnLineForm};

//DbTreeImport in '..\Units\DbTreeImport.pas',
  //DbTreeDm in '..\DataModules\DbTreeDm.pas' {DbTreeData: TDataModule},
  //DebugUsers in '..\Units\DebugUsers.pas';

{$R *.res}

var
  IPForm: TIPForm;

begin
  Application.Initialize;
  Application.Title := 'ݺṫ·̽һ廯';

  {$IFDEF _mCloud}
    IPForm := TIPForm.Create(nil);
    try
      if not IPForm.HasIP then
      begin
        IPForm.ShowModal;
        if IPForm.ModalResult <> mrOK then
        begin
          Application.Terminate;
          Exit;
        end;
      end;
    finally
      IPForm.Free;
    end;

    if not LoginForm then
    begin
      Application.Terminate;
      Exit;
    end;
  {$ENDIF}

  ShowWelcome;
  if CheckDogExists then
  begin
    HideWelcome;
    Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TSetGuestForm, SetGuestForm);
  end
  else HideWelcome;

  Application.Run;
end.
