{*******************************************************************************
  Ԫƣ  UpFileManageFrame.pas

  Ԫ˵  ֧UI档

  ʱ䣺  Chenshilong, 2015-01-13
*******************************************************************************}
unit UpFileManageFrame;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, StdCtrls, ExtCtrls, PNGButton, UpFileFrame, UpFileManageUnit, sdDB,
  Menus, Buttons;

type
  TUpFileManageView = class(TFrame)
    pnlHead: TPanel;
    lblBillName: TLabel;
    btnSelectUpFile: TPNGButton;
    Shape5: TShape;
    Label6: TLabel;
    Label7: TLabel;
    Shape6: TShape;
    pnlDetail: TPanel;
    btnEditNo: TPNGButton;
    btnEdit: TPNGButton;
    lblCaption: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    btnDown: TPNGButton;
    Shape4: TShape;
    Label1: TLabel;
    Label2: TLabel;
    lblUper: TLabel;
    lblUpTime: TLabel;
    Label3: TLabel;
    lblExt: TLabel;
    Label5: TLabel;
    lblCategory: TLabel;
    Label4: TLabel;
    btnEditYes: TPNGButton;
    mmMemo: TMemo;
    edtFileName: TEdit;
    sbFile: TScrollBox;
    tDelView: TTimer;
    pmUp: TPopupMenu;
    miLocalUp: TMenuItem;
    miServerUp: TMenuItem;
    procedure btnEditClick(Sender: TObject);
    procedure btnEditYesClick(Sender: TObject);
    procedure btnEditNoClick(Sender: TObject);
    procedure btnSelectUpFileClick(Sender: TObject);
    procedure tDelViewTimer(Sender: TObject);
    procedure btnDownClick(Sender: TObject);
    procedure miLocalUpClick(Sender: TObject);
    procedure miServerUpClick(Sender: TObject);
    procedure FrameMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
  private
    FBeginRefresh: Boolean;
    FDetailIsEdit: Boolean;
    FSelected: TUpFileView;
    FDatas: TUpFiles;
    FWaitForDelete: TUpFileView;
    FDeleteAttachmentOnLine: Boolean;
    FProjectData: TObject;
    FRec: TsdDataRecord;
    procedure SetSelected(const Value: TUpFileView);
    procedure SetDetailIsEdit(const Value: Boolean);
    procedure SetDatas(const Value: TUpFiles);
    procedure RefreshOtherFileFrames;
    procedure RefreshDetail;
    procedure RefreshBill;
    procedure ClearViews;
    procedure ClearDetail;

    procedure DetailOutEditStatus;
    procedure DetailIntoEditStatus;
    procedure AddUpFileView(AUpFile: TUpFile);
    procedure SetWaitForDelete(const Value: TUpFileView);
    procedure SetRec(const Value: TsdDataRecord);
    procedure SelectUpFile;

  public
    constructor Create(AOwner: TComponent; AProjectData: TObject);
    procedure DeleteViewAndData(AView: TUpFileView; ANeedDeleteOnLine: Boolean);
    procedure DoOnBillChange(ARec: TsdDataRecord);
    procedure RefreshViews;

    property ProjectData: TObject read FProjectData;
    property Selected: TUpFileView read FSelected write SetSelected;
    property DetailIsEdit: Boolean read FDetailIsEdit write SetDetailIsEdit;   // ϸִ༭״̬
    property Datas: TUpFiles read FDatas write SetDatas;
    property WaitForDelete: TUpFileView read FWaitForDelete write SetWaitForDelete;
    property Rec: TsdDataRecord read FRec write SetRec;
  end;

implementation

uses PHPWebDm, ProjectData, IdGlobal, ProjectFme, ConstUnit, MainFrm,
  BillsMeasureDm, UtilMethods, UpFileSelectOnLineFrm, ShellAPI;

{$R *.dfm}

{ TUpFileManageView }


procedure TUpFileManageView.ClearDetail;
begin
  edtFileName.Text := '';
  lblExt.Caption := '';
  lblUper.Caption := '';
  lblUpTime.Caption := '';
  lblCategory.Caption := '';
  mmMemo.Clear;
  btnEdit.Enabled := False;
  btnDown.Enabled := False;
end;

procedure TUpFileManageView.DetailIntoEditStatus;
begin
  edtFileName.BorderStyle := bsSingle;
  edtFileName.ReadOnly := False;
  mmMemo.BorderStyle := bsSingle;
  mmMemo.ReadOnly := False;
  btnEdit.Visible := False;
  btnEditYes.Visible := True;
  btnEditNo.Visible := True;
end;

procedure TUpFileManageView.DetailOutEditStatus;
begin
  edtFileName.BorderStyle := bsNone;
  edtFileName.ReadOnly := True;
  mmMemo.BorderStyle := bsNone;
  mmMemo.ReadOnly := True;
  btnEdit.Visible := True;
  btnEditYes.Visible := False;
  btnEditNo.Visible := False;
end;

procedure TUpFileManageView.ClearViews;
var
  i: Integer;
  obj: TControl;
begin
  for i := sbFile.ControlCount - 1 downto 0 do
  begin
    obj := sbFile.Controls[i];
    if Assigned(obj) then
    begin
      sbFile.RemoveControl(obj);
      obj.Free;
    end;
  end;
end;

procedure TUpFileManageView.RefreshViews;
var i: Integer;
begin
  LockWindowUpdate(Self.Handle);
  try
    btnSelectUpFile.Visible := (not TProjectData(FProjectData).IsHistoryPhase) and (not TProjectData(FProjectData).IsGuest);
    ClearViews;
    ClearDetail;
    {'HasAttachment'ǲɿġһɿᵼ£иȴʾûΪ
     ʧɿΪ
     ûϴɹر޸ɣ֮ȴĿûбɹ
       رûб棬²һ¡
     ڵǰûǹ״̬ϴ˸ȴ´δӷ¸˱ĿǶʧ}
    if (FRec <> nil) {and (FRec.ValueByName('HasAttachment').AsBoolean = True)} then
      for i := 0 to Datas.Count - 1 do
      begin
        if Assigned(Datas[i]) then
          if (Datas[i].BillID = FRec.ValueByName('ID').AsInteger) and (Datas[i].Phase = TProjectData(FProjectData).PhaseIndex) then
            AddUpFileView(Datas[i]);
      end;
  finally
    pnlHead.Repaint;
    LockWindowUpdate(0);
  end;
end;

procedure TUpFileManageView.RefreshDetail;
var vFile: TUpFile;
begin
  if DetailIsEdit then
    DetailOutEditStatus;

  vFile := Selected.Data;
  if vFile.Status <> ufsNormal then
    ClearDetail
  else
  begin
    edtFileName.Text :=  ExtractFileNameWithoutExt(vFile.DisplayName);
    lblExt.Caption := ExtractFileExt(vFile.LocalFile);
    lblUper.Caption := vFile.UperName;
    lblUpTime.Caption := vFile.UpTime;
    lblCategory.Caption := vFile.Category;
    mmMemo.Text := vFile.Memo;
  end;

  btnEdit.Enabled := (edtFileName.Text <> '') and (PHPWeb.UserID = vFile.UperID); // TProjectData(FProjectData).CurUserIsAuthor;
  btnDown.Enabled := (edtFileName.Text <> '');
end;

procedure TUpFileManageView.RefreshOtherFileFrames;
var i: Integer;
begin
  for i := 0 to sbFile.ControlCount - 1 do
  begin
    if TUpFileView(sbFile.Controls[i]) <> Selected then
      TUpFileView(sbFile.Controls[i]).ShowNormal;
  end;
end;

procedure TUpFileManageView.SetSelected(const Value: TUpFileView);
begin
  FSelected := Value;
  RefreshOtherFileFrames;
  if G_IsCloud then
    RefreshDetail;
end;

procedure TUpFileManageView.SetDetailIsEdit(const Value: Boolean);
begin
  FDetailIsEdit := Value;
end;

procedure TUpFileManageView.btnEditClick(Sender: TObject);
begin
  DetailIntoEditStatus;
  DetailIsEdit := True;
end;

procedure TUpFileManageView.btnEditYesClick(Sender: TObject);
var sURL, sExt, sNewName, sNewMemo, sNewFile: string;
  vArr: array of string;
begin
  sExt := Selected.Data.Ext;
  sNewName := Trim(edtFileName.Text);
  if HasExt(sNewName) then
    sNewName := ExtractFileNameWithoutExt(sNewName);

  sNewFile := ExtractFilePath(Selected.Data.LocalFile) + sNewName + sExt;
  // жϣֻ˱עûиļύϡ
//  if FileExists(sNewFile) then
//  begin
//    Application.MessageBox('Ѵͬļƣ', '༭ʧ', MB_OK + MB_ICONWARNING);
//    Exit;
//  end;

  sURL := Format('%stender/attachment/info/%d/update', [PHPWeb.MeasureURL, Selected.Data.ID]);
  sNewMemo := mmMemo.Text;
  vArr := VarArrayOf(['msg']);

  if PHPWeb.Search(sURL, ['FileName', 'Memo'], [sNewName, sNewMemo], vArr) = 1 then
  begin
    if FileExists(Selected.Data.LocalFile) then
      if not RenameFile(Selected.Data.LocalFile, sNewFile) then
      begin
        Application.MessageBox('ļռãļʧܣرռļԣ', '༭ʧ', MB_OK + MB_ICONWARNING);
        Exit;
      end;

    Selected.Data.LocalFile := sNewFile;
    Selected.Data.DisplayName := sNewName + sExt;
    Selected.Data.Memo := sNewMemo;
    Selected.Refresh;
    edtFileName.Text := sNewName;

    DetailOutEditStatus;
    DetailIsEdit := False;
  end
  else
  begin
    Application.MessageBox('ԭ±༭ʧܣԣ', '༭ʧ', MB_OK + MB_ICONWARNING);
    Exit;
  end;
end;

procedure TUpFileManageView.btnEditNoClick(Sender: TObject);
begin
  DetailOutEditStatus;
  DetailIsEdit := False;
  edtFileName.Text := Selected.Data.DisplayName;
  mmMemo.Text := Selected.Data.Memo;
end;

procedure TUpFileManageView.btnSelectUpFileClick(Sender: TObject);
var
  P: TPoint;
begin
  GetCursorPos(P);
  pmUp.Popup(P.X, P.Y);
end;

procedure TUpFileManageView.SetDatas(const Value: TUpFiles);
begin
  FDatas := Value;
end;

procedure TUpFileManageView.AddUpFileView(AUpFile: TUpFile);
var vVew: TUpFileView;
begin
  vVew := TUpFileView.Create(Self);
// ɾظ
//  vVew.Name := Format('UpFileView%d', [AUpFile.No]);    // ʱIDĩȡID
  vVew.Name := Format('UpFileView_%s', [PHPWeb.TempName]);
  vVew.ProjectData := FProjectData;
  sbFile.InsertControl(vVew);
  vVew.Align := alTop;
  vVew.Data := AUpFile;
end;

procedure TUpFileManageView.DeleteViewAndData(AView: TUpFileView; ANeedDeleteOnLine: Boolean);
begin
  WaitForDelete := AView;
  FDeleteAttachmentOnLine := ANeedDeleteOnLine;
  tDelView.Enabled := True;
end;

procedure TUpFileManageView.tDelViewTimer(Sender: TObject);
var vUpFile: TUpFile;
begin
  tDelView.Enabled := False;
  vUpFile := WaitForDelete.Data;
  if FDeleteAttachmentOnLine then
    if PHPWeb.DeleteAttachment(vUpFile.ID) <> 1 then
    begin
      Application.MessageBox('ϸƳʧܣԣ', '', MB_OK + MB_ICONWARNING);
      Exit;
    end;
  sbFile.RemoveControl(WaitForDelete);
  WaitForDelete.Free;
  Datas.Delete(vUpFile);
  vUpFile.Free;
end;

procedure TUpFileManageView.SetWaitForDelete(const Value: TUpFileView);
begin
  FWaitForDelete := Value;
end;

procedure TUpFileManageView.btnDownClick(Sender: TObject);
var svDlg: TSaveDialog;
  sFile, sName, sPath: string;
begin
  if not Assigned(Selected) then Exit;

  svDlg := TSaveDialog.Create(nil);
  svDlg.InitialDir := ExtractFilePath(Application.ExeName) + 'UserData\';
  svDlg.FileName := Selected.Data.DisplayName;

  try
    if svDlg.Execute then
    begin 
      if FileExists(svDlg.FileName) then
       begin
         if Application.MessageBox('ļѴڣǷ񸲸ǣ', 'ѯ', MB_YESNO) = ID_NO then
           Exit;
       end;

      Screen.Cursor := crHourGlass;
      Selected.Data.Status := ufsDowning;
      sFile := svDlg.FileName;
      if PHPWeb.DownFile(Selected.Data.DownURL, sFile) then
      begin
        Selected.Data.Status := ufsNormal;
        sName := ExtractFileName(sFile);
        sPath := ExtractFilePath(sFile);
        TProjectData(FProjectData).AttachmentInfoData.SaveAttachmentPath(Selected.Data.ID, sFile);
        ShellExecute(Handle, 'open', pchar(sName), nil, pchar(sPath), SW_SHOWNORMAL);
      end
      else
      begin
        Selected.Data.Status := ufsDownFail;
      end;
    end 
    else 
      Exit;
  finally
    svDlg.Free;
    Screen.Cursor := crDefault;
  end;
end;

constructor TUpFileManageView.Create(AOwner: TComponent; AProjectData: TObject);
begin
  inherited Create(AOwner);
  FProjectData := AProjectData;
  FBeginRefresh := False;
  FRec := nil;
  lblBillName.Caption := '';
  lblBillName.Update;

  pnlDetail.Visible := G_IsCloud;

  TProjectFrame(AOwner).BillsMeasureFrame.BillsMeasureData.OnRecChange := DoOnBillChange;
  TProjectFrame(AOwner).BillsCompileFrame.BillsCompileData.OnRecChange := DoOnBillChange;
end;

procedure TUpFileManageView.DoOnBillChange(ARec: TsdDataRecord);
begin
  with TProjectFrame(Owner) do
  begin
    if not (jpsAssistant.Visible and (jpsAssistant.ActivePage = jpsAssistantUpFile)) then
      Exit;
  end;
  if FBeginRefresh then Exit;

  FBeginRefresh := True;
  try
    FRec := ARec;
    RefreshBill;
    RefreshViews;
  finally
    FBeginRefresh := False;
  end;
end;

procedure TUpFileManageView.SetRec(const Value: TsdDataRecord);
begin
  FRec := Value;
end;

procedure TUpFileManageView.RefreshBill;
var sCode: string;
begin
  if FRec <> nil then
  begin
    if FRec.ValueByName('Code').AsString <> '' then
      sCode := FRec.ValueByName('Code').AsString
    else
      sCode := FRec.ValueByName('B_Code').AsString;
    if sCode <> '' then
      sCode := sCode + ' ';

    lblBillName.Caption := sCode + FRec.ValueByName('Name').AsString;
  end
  else
    lblBillName.Caption := '';
    
  lblBillName.Update;
end;

procedure TUpFileManageView.SelectUpFile;
var vODlg: TOpenDialog;
  i, iBillID: Integer;
  vFile: TUpFile;
  sFile, sFile2, sName, sName2: string;
  iV: Int64;
begin
  vODlg := TOpenDialog.Create(nil);
  vODlg.Options := vODlg.Options + [ofAllowMultiSelect];

  if vODlg.Execute then
  begin
    for i := 0 to vODlg.Files.Count - 1 do
    begin
      sFile := vODlg.Files[i];
      iV := FileSizeByName(sFile);
      if iV >= 52428800 then
      begin
        Application.MessageBox(PChar('' + sFile + '󣬵ļϴܳ50M'), 'ʾ', MB_OK + MB_ICONINFORMATION);
        Continue;
      end;

      with MainForm.CurProjectFrame.dxsbViewControl do
      begin
        if SelectedItem = Groups[0].Items[0] then
          iBillID := TProjectData(FProjectData).BillsCompileData.BillsCompileTree.Selected.ID
        else if SelectedItem = Groups[0].Items[1] then
          iBillID := TProjectData(FProjectData).BillsMeasureData.BillsMeasureTree.Selected.ID;
      end;

      sName := ExtractFileName(sFile);
      sName2 := PHPWeb.RepalceSpecChars(sName);

      sFile2 := sFile;
      if sName2 <> sName then
      begin
        sFile2 := ExtractFilePath(sFile) + sName2;
        CopyFile(PChar(sFile), PChar(sFile2), False);
      end;

      vFile := Datas.Add(iBillID);
      vFile.Phase := TProjectData(FProjectData).PhaseIndex;
      vFile.OrgFile := sFile2;
      vFile.Category := '̨ʸ';
      vFile.Memo := 'ҵıע';
      vFile.LocalFile := Datas.Path + sName2;
      vFile.DisplayName := sName2;
      vFile.Status := ufsNeedUp;

      if G_IsCloud then
      begin
        // ӵϴIDٵ޸IDΪʲôϴID
        // ӵಢIDһǳأΪҪûһû
        // ȡĳϴࡣ
        vFile.WebID := TProjectData(FProjectData).WebID;
        vFile.UperID := PHPWeb.UserID;
        vFile.UperName := PHPWeb.RealName;
        vFile.UpTime := FormatDateTime('yyyy-mm-dd hh:mm', Now);
      end
      else
      begin
        //
      end;

      AddUpFileView(vFile);
    end;
  end;
  Application.ProcessMessages;
end;

procedure TUpFileManageView.miLocalUpClick(Sender: TObject);
begin
  SelectUpFile;
end;

procedure TUpFileManageView.miServerUpClick(Sender: TObject);
var
  vForm: TUpFileSelectOnLineForm;
begin
  vForm := TUpFileSelectOnLineForm.Create(nil);
  try
    vForm.InitData(FDatas.List);
    if vForm.ModalResult = mrOK then
    begin
      vForm.UpOnlineFiles;
    end;
  finally
    vForm.Free;
  end;

end;

procedure TUpFileManageView.FrameMouseWheel(Sender: TObject;
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin
  if WheelDelta < 0 then
    sbFile.Perform(WM_VSCROLL, SB_LINEDOWN, 0)
  else
    sbFile.Perform(WM_VSCROLL, SB_LINEUP, 0);
end;

end.
