{*******************************************************************************
  Ԫƣ  CheckerFme.pas

  Ԫ˵  ˴ڡ

  ʱ䣺  Chenshilong, 2014-07-11
*******************************************************************************}

unit CheckerFme;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, OrderCheckerFme, JimLabels, Contnrs, Checker;

type
  TCheckerFrame = class(TFrame)
    pnlProject: TPanel;
    sbChecker: TScrollBox;
    pnlTitle: TPanel;
    labTitle: TJimGradLabel;
    tRefreshCheckers: TTimer;
    procedure tRefreshCheckersTimer(Sender: TObject);
  private
    FProjectData: TObject;
    FCount: Integer;
    FOwnerFrame: TOrderCheckerFrame;
    FAddFrame: TOrderCheckerFrame;
    FList: TList;          // AddҲFList
    FCurPos: Integer;
  public
    constructor Create(AParent: TComponent; AProject: TObject);
    destructor Destroy; override;

    procedure Init;
    // ˵ְ֡λ˾ͼ
    procedure AddNewChecker(AType: TCheckerFrameType; AID: Integer; AName,
      ARole, ACompany, AImagePath, ACheckerMemo: string; ACheckStatus: TCheckStatus;
      ACheckeTime: string; ACheckeOnLine: Integer);
    function InCheckerList(ACheckerID: Integer): Boolean;
    function HasNormalChecker: Boolean;        // ͨ˾ͷTrueҵ㣩
    function HasChecker: Boolean;              // бΪռTrueAddҲ㣩
    procedure CheckerNameList(var ASL: TStringList);
    procedure RepairOrder;
    procedure RepairDelete(ACanDelete: Boolean);
    function FirstChecker: TOrderCheckerFrame;
    function NextChecker: TOrderCheckerFrame;
    function LastChecker: TOrderCheckerFrame;
    function Me: TOrderCheckerFrame;

    function CheckNo(ACheckStatus: TCheckStatus): Integer;                // ָ״̬беĵڼ

    property ProjectData: TObject read FProjectData;
    property OwnerFrame: TOrderCheckerFrame read FOwnerFrame write FOwnerFrame;  // ָ˵Frame
    property AddFrame: TOrderCheckerFrame read FAddFrame write FAddFrame;        // ָ˵Frame
    property List: TList read FList;
    property CurPos: Integer read FCurPos write FCurPos;
  end;


implementation

uses FindUserFrm, PHPWebDm, ProjectData, CslJson, ConstUnit, ProjectFme, superobject, ZhAPI;

{$R *.dfm}

procedure TCheckerFrame.AddNewChecker(AType: TCheckerFrameType; AID: Integer;
  AName, ARole, ACompany, AImagePath, ACheckerMemo: string; ACheckStatus: TCheckStatus;
  ACheckeTime: string; ACheckeOnLine: Integer);
var vChecker: TOrderCheckerFrame;
begin
  vChecker := TOrderCheckerFrame.Create(Self);
  vChecker.Init(AType, AID, AName, ARole, ACompany, AImagePath, ACheckerMemo, ACheckStatus, ACheckeTime, ACheckeOnLine);

  sbChecker.Height := sbChecker.Height + vChecker.Height;
  vChecker.Parent := sbChecker;
  vChecker.Top := FCurPos;
  FCurPos := FCurPos + vChecker.Height;
  vChecker.Align := alTop;

  // λ
  case AType of
    cftChecker:
    begin
      vChecker.Name := 'OrderFrame' + IntToStr(AID);
      if Assigned(AddFrame) then       // ڲݿ󣬲Add֮ǰ
      begin
        vChecker.Top := AddFrame.Top;
        AddFrame.Top := vChecker.Top + vChecker.Height;
        OwnerFrame.Top := AddFrame.Top + AddFrame.Height;
        FList.Insert(FList.Indexof(AddFrame), vChecker);
      end
      else
        FList.Add(vChecker);
    end;
    cftOwner:      // գ֤һAdd֮
    begin
      OwnerFrame := vChecker;
      vChecker.Name := 'OwnerFrame';
      if Assigned(AddFrame) then
        OwnerFrame.Top := AddFrame.Top + AddFrame.Height;
      FList.Add(vChecker);
    end;
    cftAdd:        // Add뵽֮ǰ
    begin
      AddFrame := vChecker;
      vChecker.Name := 'AddFrame';
      if Assigned(OwnerFrame) then
      begin
        AddFrame.Top := OwnerFrame.Top;
        OwnerFrame.Top := AddFrame.Top + AddFrame.Height;
        FList.Insert(FList.Indexof(OwnerFrame), vChecker);
      end
      else
        FList.Add(vChecker);
    end;
  end;
end;

procedure TCheckerFrame.Init;

  procedure AddChecker(AChecker: ISuperObject; AProj: TProjectData);
  var
    sID, sPicPath: String; 
    vStatus: TCheckStatus; 
    bOwner, bOwnerFinish: Boolean;
    iIndex: Integer;
  begin
    sID := AChecker.S['uid'];
    sPicPath := PHPWeb.UserPath + '1_' + sID + '.jpg';
    PHPWeb.DownFile(AChecker.S['avatar'], sPicPath);
    vStatus :=  TCheckStatus(AChecker.I['mastatus'] - 1);  // Json1234
    bOwner := StrToInt(sID) = TProjectData(ProjectData).WebOwnerID;
    if bOwner then   // ҵ
    begin
      if TProjectData(ProjectData).CurUserIsAuthor then
      begin
       {ǱˣҵǰAdd
       ݿУû״ֻ̬иε״̬
       бΣ˳¼˱ˣǱ˴ģ ûбΡ

       ΪʲôͨǷбжϵǰǷʾµˡأ
       Ϊ޷֪ǰĿݿѴڵһڻǽڱĩ
       һڡӵλøʾ}
       if (TProjectData(ProjectData).PhaseIndex > 0) and (not TProjectFrame(Owner).IsUped) then
         AddNewChecker(cftAdd, -1, '', '', '', '', '', csNotBegin, '', -1);
      end;

      AddNewChecker(cftOwner, StrToInt(sID),
        AChecker.S['name'], AChecker.S['jobs'], AChecker.S['company'], sPicPath,
        AChecker.S['CheckerMemo'], vStatus, AChecker.S['audittime'], AChecker.I['onlineaudit']);
    end
    else
      AddNewChecker(cftChecker, StrToInt(sID),
        AChecker.S['name'], AChecker.S['jobs'], AChecker.S['company'], sPicPath,
        AChecker.S['CheckerMemo'], vStatus, AChecker.S['audittime'], AChecker.I['onlineaudit']);

    iIndex := AProj.Checkers.Add(StrToInt(sID), AChecker.S['name'],
      AChecker.S['jobs'], AChecker.S['CheckerMemo'], AChecker.S['audittime']);
    if vStatus in [csFinished, csNotPass] then
      AProj.Checkers.LastChecker := AProj.Checkers.Item[iIndex]
    else
      AProj.Checkers.LastChecker := nil;
  end;

var
  i, iCount: Integer;
  sURL, sPicPath, sID, sErrors, sResult: string;
  vProj: TProjectData;
  bOwner, bOwnerFinish: Boolean;
  vJ: ISuperObject;
begin  
  ClearObjects(FList);
  FList.Clear;
  OwnerFrame := nil;
  AddFrame := nil;
  sbChecker.Height := 0;
  FCurPos := 0;

  vProj := TProjectData(FProjectData);
  vProj.Checkers.Clear;

  // ...˵һϱ󣬹صĿ´ĿһΣ
  // ˵ǵһΡһȡбڶΡԺÿζ֪
  // ȡбĺжÿ䶼˵Ľɫ
  // Ժֱӱ޷ʹáԭ򣺷ͷPHPһνղ˴
  // ȥݣ־ʾȡΪա
  // ѲƵURLУͨURLķʽݣܿ鴫ݣ
  // ԣַʽľԺֻܴʺϲٵѱ麣ݺṫ˾
  // ֧зŶӶΪPHPҵ¼ÿѧ
  // һҪҸԵɡchenshilong, 2014-07-21
  sURL := Format('%suser/get/all/%d/%d/measure', [PHPWeb.MeasureURL, vProj.WebID, vProj.PhaseIndex]);
  if PHPWeb.UrlGet(sURL, nil, sResult) = 1 then
  begin
    vJ := SO(sResult);
    try
      if not Assigned(vJ.AsArray) then Exit;
      iCount := vJ.AsArray.Length;
      for i := 0 to iCount - 1 do
        AddChecker(vJ.AsArray.O[i], vProj);
      RepairOrder;
    finally
      vJ := nil;
    end;
  end
  else
  begin
    sErrors := Format('޷ȡб⽫ᵼ%sַ%s%sID%sںţ%s',
      [#13#10#13#10, sURL, #13#10#13#10, IntToStr(vProj.WebID), IntToStr(vProj.PhaseIndex)]);
    Application.MessageBox(PChar(sErrors), '', MB_OK + MB_ICONERROR);
    Application.Terminate;
  end;
end;

function TCheckerFrame.InCheckerList(ACheckerID: Integer): Boolean;
var i: Integer;
begin
  Result := False;
  for i := 0 to FList.Count - 1 do
  begin
    if TOrderCheckerFrame(FList[i]).UserID = ACheckerID then
    begin
      Result := True;
      Break;
    end;
  end;
end;

procedure TCheckerFrame.CheckerNameList(var ASL: TStringList);
var i: Integer;
  vFrame: TOrderCheckerFrame;
begin
  ASL.Clear;
  for i := 0 to FList.Count - 1 do
  begin
    vFrame := TOrderCheckerFrame(FList[i]);
    if vFrame.CheckerFrameType <> cftAdd then
      ASL.Add(Format('%s', [vFrame.UserName]));
  end;
end;

procedure TCheckerFrame.RepairOrder;
var i: Integer;
begin
  for i := 0 to FList.Count - 1 do
    TOrderCheckerFrame(FList[i]).Order := i + 1;
end;

function TCheckerFrame.HasNormalChecker: Boolean;
var i: Integer;
begin
  Result := False;
  for i := 0 to FList.Count - 1 do
  begin
    if TOrderCheckerFrame(FList[i]).CheckerFrameType = cftChecker then
    begin
      Result := True;
      Break;
    end;
  end;
end;

constructor TCheckerFrame.Create(AParent: TComponent; AProject: TObject);
begin
  inherited Create(AParent);
  FProjectData := AProject;
  FList := TList.Create;
end;

destructor TCheckerFrame.Destroy;
begin
  ClearObjects(FList);
  FList.Free;
  inherited;
end;

function TCheckerFrame.FirstChecker: TOrderCheckerFrame;
begin
  Result := nil;
  if FList.Count > 0 then
  begin
    if TOrderCheckerFrame(FList[0]).CheckerFrameType <> cftAdd then
      Result := TOrderCheckerFrame(FList[0])
    else
      Result := TOrderCheckerFrame(FList[1]);
  end;
end;

function TCheckerFrame.NextChecker: TOrderCheckerFrame;
var i: Integer;
  vFrame: TOrderCheckerFrame;
begin
  Result := nil;
  if FList.Count = 0 then Exit;

  for i := 0 to FList.Count - 1 do
  begin
    if (TOrderCheckerFrame(FList[i]).UserID = PHPWeb.UserID) then
    begin
      if i = (FList.Count - 1) then Exit;     // һ

      Result := TOrderCheckerFrame(FList[i + 1]);
      if Result.CheckerFrameType = cftAdd then
        Result := TOrderCheckerFrame(FList[i + 2]);

      Break;
    end;
  end;
end;

function TCheckerFrame.Me: TOrderCheckerFrame;
var i: Integer;
begin
  Result := nil;
  for i := 0 to FList.Count - 1 do
  begin
    if TOrderCheckerFrame(FList[i]).UserID = PHPWeb.UserID then
    begin
      Result := TOrderCheckerFrame(FList[i]);
      Break;
    end;
  end;
end;

procedure TCheckerFrame.RepairDelete(ACanDelete: Boolean);
var i: Integer;
begin
  for i := 0 to FList.Count - 1 do
  begin
    if (TOrderCheckerFrame(FList[i]) <> OwnerFrame) and
      (TOrderCheckerFrame(FList[i]) <> AddFrame) then
    begin
      TOrderCheckerFrame(FList[i]).lblOrderStatus.Visible := (not ACanDelete);
      TOrderCheckerFrame(FList[i]).CanDelete := ACanDelete;
    end;
  end;
end;

procedure TCheckerFrame.tRefreshCheckersTimer(Sender: TObject);
begin
  tRefreshCheckers.Enabled := False;
  try
    init;
    RepairDelete(True);
  except
    ShowMessage('ɾɹ쳣');
  end;
end;

function TCheckerFrame.HasChecker: Boolean;
begin
  Result := (FList.Count > 0);
end;

function TCheckerFrame.CheckNo(ACheckStatus: TCheckStatus): Integer;
var i, iCount: Integer;
begin
  Result := -1;
  
  for i := 0 to FList.Count - 1 do
  begin
    if TOrderCheckerFrame(FList[i]).CheckStatus = ACheckStatus then
    begin
      Result := i + 1;
      Break;
    end;
  end;
end;

function TCheckerFrame.LastChecker: TOrderCheckerFrame;
var i: Integer;
begin
  Result := FOwnerFrame;
end;

end.
