{*******************************************************************************
  Ԫƣ  OrderCheckerFme.pas

  Ԫ˵  ̬ˡ

  ʱ䣺  Chenshilong, 2014-07-11
*******************************************************************************}

unit OrderCheckerFme;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, pngimage, CslButton;

type
  TCheckerFrameType = (cftChecker, cftOwner, cftAdd);
  TCheckStatus = (csNotBegin, csChecking, csFinished, csNotPass);  // ĩˣУɣ˲ͨ

const
  CheckStatusNames: array[TCheckStatus] of string = ('δ', '', 'ͨ', 'ͨ');
  CheckStatusColors: array[TCheckStatus] of TColor = ($00B7B7B7, $000099FF, $000E9D00, clRed);

type
  TOrderCheckerFrame = class(TFrame)
    pnlChecker: TPanel;
    shpImage: TShape;
    imgOrderCheckerPic: TImage;
    lblOrderCheckerName: TLabel;
    lblOrderCheckerRole: TLabel;
    lblOrderCheckerCompany: TLabel;
    shpBotom: TShape;
    lblOrderCheckerNum: TLabel;
    lblOrderStatus: TLabel;
    lblLast: TLabel;
    lblAdd: TLabel;
    lblAddHint: TLabel;
    shpAdd: TShape;
    imgStatus: TImage;
    btnDelete: TCslButton;
    lblOrderCheckerMemo: TLabel;
    lblOrderCheckerTime: TLabel;
    procedure shpAddMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnDeleteClick(Sender: TObject);
  private
    FUserID: Integer;
    FOrder: Integer;
    FUserName: string;
    FCheckerFrameType: TCheckerFrameType;
    FCheckStatus: TCheckStatus;
    FUserRole: string;
    FCheckerMemo: string;
    FCheckedTime: string;
    FCheckedOnline: Integer;
    procedure SetOrder(const Value: Integer);
    procedure SetCheckStatus(const Value: TCheckStatus);
    procedure SetCheckerMemo(const Value: string);
    procedure SetCheckedTime(const Value: string);
    procedure RightAlign(ALabel: TLabel);
    procedure SetCanDelete(const Value: Boolean);
    { Private declarations }
  public
    { Public declarations }
    procedure Init(AType: TCheckerFrameType; AID: Integer; AName, ARole,
    ACompany, AImagePath, ACheckerMemo: string; ACheckStatus: TCheckStatus;
    ACheckedTime: string; ACheckedOnLine: Integer);
    function IsMe(AID: Integer; AName: string): string;
    function IsChecking: Boolean;
    function IsFinished: Boolean;

    property UserID: Integer read FUserID write FUserID;
    property UserName: string read FUserName write FUserName;
    property UserRole: string read FUserRole write FUserRole;
    property Order: Integer read FOrder write SetOrder;
    property CheckerFrameType: TCheckerFrameType read FCheckerFrameType write FCheckerFrameType;   // 
    property CheckStatus: TCheckStatus read FCheckStatus write SetCheckStatus;     // ״̬
    property CheckerMemo: string read FCheckerMemo write SetCheckerMemo;           // 
    property CheckedTime: string read FCheckedTime write SetCheckedTime;
    property CheckedOnLine: Integer read FCheckedOnLine write FCheckedOnLine;  // 0 (Ĭ)1 

    property CanDelete: Boolean write SetCanDelete;
  end;

implementation

uses FindUserFrm, CheckerFme, PHPWebDm, ProjectData, ProjectFme,
  UtilMethods, Globals;

{$R *.dfm}

{ TOrderCheckerFrame }

procedure TOrderCheckerFrame.Init(AType: TCheckerFrameType; AID: Integer;
  AName, ARole, ACompany, AImagePath, ACheckerMemo: string;
  ACheckStatus: TCheckStatus; ACheckedTime: string; ACheckedOnLine: Integer);
var bAdd, bOwner: Boolean;
  sOnLine: string;
begin
  bAdd := AType = cftAdd;
  shpAdd.Visible := bAdd;
  lblAdd.Visible := bAdd;
  lblAddHint.Visible := bAdd;
  lblOrderCheckerName.Visible := not bAdd;
  lblOrderCheckerRole.Visible := not bAdd;
  lblOrderCheckerCompany.Visible := not bAdd;
  lblOrderStatus.Visible := not bAdd;

  shpImage.Visible := not bAdd;
  lblOrderCheckerMemo.Visible := not bAdd;
  bOwner := AType = cftOwner;
  lblLast.Visible := bOwner;
  lblOrderCheckerNum.Visible := not bOwner;

  CheckerFrameType := AType;
  CheckStatus := ACheckStatus;

  lblOrderStatus.Visible := not bAdd;
  if lblOrderStatus.Visible then
    RightAlign(lblOrderStatus);

  lblOrderCheckerTime.Visible := (not bAdd) and (CheckStatus in [csFinished, csNotPass]);
  if lblOrderCheckerTime.Visible then
    RightAlign(lblOrderCheckerTime);

  case AType of
    cftChecker, cftOwner:
    begin
      UserID := AID;
      UserName := IsMe(AID, AName);
      UserRole := ARole;

      lblOrderCheckerName.Caption := UserName;
      lblOrderCheckerRole.Caption := ARole;
      lblOrderCheckerCompany.Caption := ACompany;

      if CheckStatus in [csFinished, csNotPass] then
      begin
        CheckedOnLine := ACheckedOnLine;
        if ACheckedOnLine = 0 then
          sOnLine := ''
        else if ACheckedOnLine = 1 then
          sOnLine := '';

        CheckedTime := Format('[%s][%s]', [ACheckedTime, sOnLine]);
      end;

      CheckerMemo := RecoverCharsFromJson(ACheckerMemo);
      if FileExists(AImagePath) then
        imgOrderCheckerPic.Picture.LoadFromFile(AImagePath)
      else
        imgOrderCheckerPic.Picture.LoadFromFile(ExtractFilePath(Application.ExeName) + 'DefaultImage.jpg');
    end;
    cftAdd:
    begin
      UserID := -1;
      UserName := '';
      UserRole := '';
    end;
  end;
end;

function TOrderCheckerFrame.IsChecking: Boolean;
begin
  Result := CheckStatus = csChecking;
end;

function TOrderCheckerFrame.IsFinished: Boolean;
begin
  Result := CheckStatus = csFinished;
end;

function TOrderCheckerFrame.IsMe(AID: Integer; AName: string): string;
begin
  if AID = PHPWeb.UserID then
    Result := AName + 'ң'
  else
    Result := AName;
end;

// ״̬״̬ơɫ״̬ơ󡢱ţͼ߿
procedure TOrderCheckerFrame.SetCheckStatus(const Value: TCheckStatus);
var vColor: TColor;
begin
  FCheckStatus := Value;
  lblOrderStatus.Caption := CheckStatusNames[Value];
  RightAlign(lblOrderStatus);
  vColor := CheckStatusColors[Value];
  lblOrderCheckerNum.Font.Color := vColor;
  lblOrderStatus.Font.Color := vColor;
  lblLast.Font.Color := vColor;
  lblOrderCheckerMemo.Font.Color := vColor;
  lblOrderCheckerTime.Font.Color := vColor;

  imgStatus.Visible := True;
  if FCheckerFrameType <> cftAdd then
  begin
    case Value of
      csNotBegin:
        imgStatus.Picture.LoadFromFile(GetAppFilePath + 'Data/img/avtra_border_gray.png');
      csChecking:
        imgStatus.Picture.loadFromFile(GetAppFilePath + 'Data/img/avtra_border_wait.png');
      csFinished:
        imgStatus.Picture.LoadFromFile(GetAppFilePath + 'Data/img/pass.png');
      csNotPass:
        imgStatus.Picture.loadFromFile(GetAppFilePath + 'Data/img/unpass.png');
    end;
  end;
end;

procedure TOrderCheckerFrame.SetOrder(const Value: Integer);
begin
  FOrder := Value;
  lblOrderCheckerNum.Caption := IntToStr(FOrder);
  lblOrderCheckerNum.Update;
end;

procedure TOrderCheckerFrame.shpAddMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  FindUserForm: TFindUserForm;
  vPD: TProjectData;
begin
  if (Button = mbLeft) and Assigned(Owner) then
  begin
    vPD := TProjectData(TCheckerFrame(Owner).ProjectData);
    FindUserForm := TFindUserForm.Create(Self, 0, [vPD.WebID, vPD.PhaseIndex]);
    try
      FindUserForm.ShowModal;
    finally
      FindUserForm.Free;
    end;
  end;
end;

procedure TOrderCheckerFrame.btnDeleteClick(Sender: TObject);
var sURL: string;
  vProj: TProjectData;
  vArr: array of string;
begin
  if Application.MessageBox('ȷҪɾ', 'ѯ', MB_YESNO + MB_ICONQUESTION) = ID_No then
    Exit;
  if not Assigned(Owner) then Exit;

  vProj := TProjectData(TCheckerFrame(Owner).ProjectData);
  sURL := Format('%suser/del/%d/%d/%d/audit', [PHPWeb.MeasureURL, Self.UserID,
    vProj.WebID, vProj.PhaseIndex]);

  vArr := VarArrayOf(['msg']);
  case PHPWeb.Search(sURL, [], [], vArr) of
    1:
    begin
      // ֱӵInit⣬Ϊ¼ûӰͱͷˣг
      // ĸԴڴ¼λԿؼڲʹⲿķ
      // 㶨ҲУCSƷⲿơ
      // BSƸCSƲһְɡ
      TCheckerFrame(Owner).tRefreshCheckers.Enabled := True;
    end;
    0:
    begin
      Application.MessageBox(PChar(PHPWeb.PageError('޷ɾ' + '[' + vArr[0] + ']')),
        '', MB_OK + MB_ICONWARNING);
      Exit;
    end;
    -1:
    begin
      Application.MessageBox(PChar(PHPWeb.NetError('޷ɾ')),
        '', MB_OK + MB_ICONWARNING);
    end;
  end;
end;

procedure TOrderCheckerFrame.SetCheckerMemo(const Value: string);
begin
  FCheckerMemo := Value;

  lblOrderCheckerMemo.Caption := ShortText(FCheckerMemo, 250);
  lblOrderCheckerMemo.Hint := CustomWidthText(FCheckerMemo, 300);
  lblOrderCheckerMemo.Update;
end;


procedure TOrderCheckerFrame.SetCheckedTime(const Value: string);
begin
  FCheckedTime := Value;

  lblOrderCheckerTime.Caption := Value;
  lblOrderCheckerTime.Visible := (CheckStatus in [csFinished, csNotPass]);
  RightAlign(lblOrderCheckerTime);
end;

procedure TOrderCheckerFrame.RightAlign(ALabel: TLabel);
begin
  ALabel.Left := btnDelete.Left + btnDelete.Width - ALabel.Width;
end;

procedure TOrderCheckerFrame.SetCanDelete(const Value: Boolean);
begin
  if (Value) then
  begin
    btnDelete.PicMouseOver.LoadFromFile(GetAppFilePath + 'Data/img/remove-checker-over.bmp');
    btnDelete.PicMouseDown.LoadFromFile(GetAppFilePath + 'Data/img/remove-checker-down.bmp');
    btnDelete.PicNormal.LoadFromFile(GetAppFilePath + 'Data/img/remove-checker.bmp');
  end; 
  btnDelete.Visible := Value;
  btnDelete.Paint;
end;

end.
